//------------------------------------
//  winnie.cpp
//  (c) Bartosz Milewski, 1995
//------------------------------------

#include "winnie.h"

// This is the entry point of every Windows program
int WINAPI WinMain
   (HINSTANCE hInst, HINSTANCE hPrevInst, char * cmdParam, int cmdShow)
{
    char className [] = "Winnie";
    char classNameButton [] = "ButtonCl";

    main_wnd_class.style = 0;
    main_wnd_class.lpfnWndProc = MainWindowProcedure;  // Window Procedure: mandatory
    main_wnd_class.cbClsExtra = 0;
    main_wnd_class.cbWndExtra = 0;
    main_wnd_class.hInstance = hInst;           // owner of the class: mandatory
    main_wnd_class.hIcon = 0;
    main_wnd_class.hCursor = ::LoadCursor (0, IDC_ARROW); // optional
    main_wnd_class.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1); // optional
    main_wnd_class.lpszMenuName = 0;
    main_wnd_class.lpszClassName = className;   // mandatory

		RegisterClass (&main_wnd_class);


    button_wnd_class.style = 0;
    button_wnd_class.lpfnWndProc = ButtonWindowProcedure;  // Window Procedure: mandatory
    button_wnd_class.cbClsExtra = 0;
    button_wnd_class.cbWndExtra = 0;
    button_wnd_class.hInstance = hInst;           // owner of the class: mandatory
    button_wnd_class.hIcon = 0;
    button_wnd_class.hCursor = ::LoadCursor (0, IDC_ARROW); // optional
    button_wnd_class.hbrBackground = (HBRUSH) (COLOR_BTNFACE + 1); // optional
    button_wnd_class.lpszMenuName = 0;
    button_wnd_class.lpszClassName = classNameButton;   // mandatory

		RegisterClass (&button_wnd_class);

    hmain_wnd = ::CreateWindow (
				// zde bychom mohli pouzit "Button" a vytvorilo by se okno podle
				// sytemove tridy okna, ktere by posilalo svemu rodicovskemu oknu
				// zpravy WM_PARENTNOTIFY
        className,              // name of a registered window class
        "Hello Windows!",                // window caption
        WS_OVERLAPPEDWINDOW,    // window style
        CW_USEDEFAULT,          // x position
        CW_USEDEFAULT,          // y position
        CW_USEDEFAULT,          // witdh
        CW_USEDEFAULT,          // height
        0,                      // handle to parent window
        0,                      // handle to menu
        hInst,              // application instance
        0 );                    // window creation data

		ShowWindow (hmain_wnd, cmdShow);
		UpdateWindow (hmain_wnd);

    hbutton1 = ::CreateWindow (
        classNameButton,              // name of a registered window class
        "Stiskni me",                // window caption
        WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP | WS_CAPTION,    // window style
        10,          // x position
        10,          // y position
        200,          // witdh
        100,          // height
        hmain_wnd,                      // handle to parent window
        0,                      // handle to menu
        hInst,              // application instance
        0 );                    // window creation data


		ShowWindow (hbutton1, SW_SHOW);
		UpdateWindow (hbutton1);

		MSG  msg;
    int status;
	// Keep pumping messages--they end up in our Window Procedure
    while ((status = GetMessage (&msg, 0, 0, 0)) != 0)
    {
        if (status == -1)
            return -1;
        DispatchMessage (&msg);
    }

    return msg.wParam;
}


// Window Procedure called by Windows with all kinds of messages
LRESULT CALLBACK MainWindowProcedure 
    (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
		// In this simple program, this is the only message we are processing
        case WM_DESTROY:
            ::PostQuitMessage (0);
            return 0; // return zero when processed
				case WM_COMMAND:
					if (wParam == 1)
						MessageBox(hwnd, "z MainWindowProcedure na WM_COMMAND", "A", 0);
				
				// kdybychom pouzili systemovou tridu okna "Button"
				//case WM_PARENTNOTIFY:
				//	if (wParam == WM_LBUTTONDOWN && lParam == hbutton1)
				//		MessageBox(hwnd, "z MainWindowProcedure na WM_PARENTNOTIFY", "A", 0);
    }
	// All the unprocessed messages go there, to be dealt in some default way
    return ::DefWindowProc (hwnd, message, wParam, lParam );
}

LRESULT CALLBACK ButtonWindowProcedure 
    (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
				case WM_LBUTTONDOWN:
//					MessageBox(hwnd, "Stisknuto tlacitko", "Info", 0);
					SendMessage(hmain_wnd, WM_COMMAND, 1, 0);
					break;
    }

	// All the unprocessed messages go there, to be dealt in some default way
    return ::DefWindowProc (hwnd, message, wParam, lParam );
}

